/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __extends } from "tslib";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { KeyVaultManagementClientContext } from "./keyVaultManagementClientContext";
var KeyVaultManagementClient = /** @class */ (function (_super) {
    __extends(KeyVaultManagementClient, _super);
    /**
     * Initializes a new instance of the KeyVaultManagementClient class.
     * @param credentials Credentials needed for the client to connect to Azure. Credentials
     * implementing the TokenCredential interface from the @azure/identity package are recommended. For
     * more information about these credentials, see
     * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
     * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
     * @azure/ms-rest-browserauth are also supported.
     * @param subscriptionId Subscription credentials which uniquely identify Microsoft Azure
     * subscription. The subscription ID forms part of the URI for every service call.
     * @param [options] The parameter options
     */
    function KeyVaultManagementClient(credentials, subscriptionId, options) {
        var _this = _super.call(this, credentials, subscriptionId, options) || this;
        _this.vaults = new operations.Vaults(_this);
        _this.operations = new operations.Operations(_this);
        return _this;
    }
    return KeyVaultManagementClient;
}(KeyVaultManagementClientContext));
// Operation Specifications
export { KeyVaultManagementClient, KeyVaultManagementClientContext, Models as KeyVaultManagementModels, Mappers as KeyVaultManagementMappers };
export * from "./operations";
//# sourceMappingURL=keyVaultManagementClient.js.map