import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { ManagementLockClientContext } from "../managementLockClientContext";
/** Class representing a AuthorizationOperations. */
export declare class AuthorizationOperations {
    private readonly client;
    /**
     * Create a AuthorizationOperations.
     * @param {ManagementLockClientContext} client Reference to the service client.
     */
    constructor(client: ManagementLockClientContext);
    /**
     * Lists all of the available Microsoft.Authorization REST API operations.
     * @param [options] The optional parameters
     * @returns Promise<Models.AuthorizationOperationsListResponse>
     */
    list(options?: msRest.RequestOptionsBase): Promise<Models.AuthorizationOperationsListResponse>;
    /**
     * @param callback The callback
     */
    list(callback: msRest.ServiceCallback<Models.OperationListResult>): void;
    /**
     * @param options The optional parameters
     * @param callback The callback
     */
    list(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.OperationListResult>): void;
    /**
     * Lists all of the available Microsoft.Authorization REST API operations.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.AuthorizationOperationsListNextResponse>
     */
    listNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.AuthorizationOperationsListNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.OperationListResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.OperationListResult>): void;
}
//# sourceMappingURL=authorizationOperations.d.ts.map