/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __assign } from "tslib";
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/managementLocksMappers";
import * as Parameters from "../models/parameters";
/** Class representing a ManagementLocks. */
var ManagementLocks = /** @class */ (function () {
    /**
     * Create a ManagementLocks.
     * @param {ManagementLockClientContext} client Reference to the service client.
     */
    function ManagementLocks(client) {
        this.client = client;
    }
    ManagementLocks.prototype.createOrUpdateAtResourceGroupLevel = function (resourceGroupName, lockName, parameters, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            lockName: lockName,
            parameters: parameters,
            options: options
        }, createOrUpdateAtResourceGroupLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.deleteAtResourceGroupLevel = function (resourceGroupName, lockName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            lockName: lockName,
            options: options
        }, deleteAtResourceGroupLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.getAtResourceGroupLevel = function (resourceGroupName, lockName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            lockName: lockName,
            options: options
        }, getAtResourceGroupLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.createOrUpdateByScope = function (scope, lockName, parameters, options, callback) {
        return this.client.sendOperationRequest({
            scope: scope,
            lockName: lockName,
            parameters: parameters,
            options: options
        }, createOrUpdateByScopeOperationSpec, callback);
    };
    ManagementLocks.prototype.deleteByScope = function (scope, lockName, options, callback) {
        return this.client.sendOperationRequest({
            scope: scope,
            lockName: lockName,
            options: options
        }, deleteByScopeOperationSpec, callback);
    };
    ManagementLocks.prototype.getByScope = function (scope, lockName, options, callback) {
        return this.client.sendOperationRequest({
            scope: scope,
            lockName: lockName,
            options: options
        }, getByScopeOperationSpec, callback);
    };
    ManagementLocks.prototype.createOrUpdateAtResourceLevel = function (resourceGroupName, resourceProviderNamespace, parentResourcePath, resourceType, resourceName, lockName, parameters, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            resourceProviderNamespace: resourceProviderNamespace,
            parentResourcePath: parentResourcePath,
            resourceType: resourceType,
            resourceName: resourceName,
            lockName: lockName,
            parameters: parameters,
            options: options
        }, createOrUpdateAtResourceLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.deleteAtResourceLevel = function (resourceGroupName, resourceProviderNamespace, parentResourcePath, resourceType, resourceName, lockName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            resourceProviderNamespace: resourceProviderNamespace,
            parentResourcePath: parentResourcePath,
            resourceType: resourceType,
            resourceName: resourceName,
            lockName: lockName,
            options: options
        }, deleteAtResourceLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.getAtResourceLevel = function (resourceGroupName, resourceProviderNamespace, parentResourcePath, resourceType, resourceName, lockName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            resourceProviderNamespace: resourceProviderNamespace,
            parentResourcePath: parentResourcePath,
            resourceType: resourceType,
            resourceName: resourceName,
            lockName: lockName,
            options: options
        }, getAtResourceLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.createOrUpdateAtSubscriptionLevel = function (lockName, parameters, options, callback) {
        return this.client.sendOperationRequest({
            lockName: lockName,
            parameters: parameters,
            options: options
        }, createOrUpdateAtSubscriptionLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.deleteAtSubscriptionLevel = function (lockName, options, callback) {
        return this.client.sendOperationRequest({
            lockName: lockName,
            options: options
        }, deleteAtSubscriptionLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.getAtSubscriptionLevel = function (lockName, options, callback) {
        return this.client.sendOperationRequest({
            lockName: lockName,
            options: options
        }, getAtSubscriptionLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.listAtResourceGroupLevel = function (resourceGroupName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            options: options
        }, listAtResourceGroupLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.listAtResourceLevel = function (resourceGroupName, resourceProviderNamespace, parentResourcePath, resourceType, resourceName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            resourceProviderNamespace: resourceProviderNamespace,
            parentResourcePath: parentResourcePath,
            resourceType: resourceType,
            resourceName: resourceName,
            options: options
        }, listAtResourceLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.listAtSubscriptionLevel = function (options, callback) {
        return this.client.sendOperationRequest({
            options: options
        }, listAtSubscriptionLevelOperationSpec, callback);
    };
    ManagementLocks.prototype.listByScope = function (scope, options, callback) {
        return this.client.sendOperationRequest({
            scope: scope,
            options: options
        }, listByScopeOperationSpec, callback);
    };
    ManagementLocks.prototype.listAtResourceGroupLevelNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listAtResourceGroupLevelNextOperationSpec, callback);
    };
    ManagementLocks.prototype.listAtResourceLevelNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listAtResourceLevelNextOperationSpec, callback);
    };
    ManagementLocks.prototype.listAtSubscriptionLevelNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listAtSubscriptionLevelNextOperationSpec, callback);
    };
    ManagementLocks.prototype.listByScopeNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listByScopeNextOperationSpec, callback);
    };
    return ManagementLocks;
}());
export { ManagementLocks };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var createOrUpdateAtResourceGroupLevelOperationSpec = {
    httpMethod: "PUT",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.ManagementLockObject), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        201: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var deleteAtResourceGroupLevelOperationSpec = {
    httpMethod: "DELETE",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {},
        204: {},
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getAtResourceGroupLevelOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var createOrUpdateByScopeOperationSpec = {
    httpMethod: "PUT",
    path: "{scope}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.scope,
        Parameters.lockName
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.ManagementLockObject), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        201: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var deleteByScopeOperationSpec = {
    httpMethod: "DELETE",
    path: "{scope}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.scope,
        Parameters.lockName
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {},
        204: {},
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getByScopeOperationSpec = {
    httpMethod: "GET",
    path: "{scope}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.scope,
        Parameters.lockName
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var createOrUpdateAtResourceLevelOperationSpec = {
    httpMethod: "PUT",
    path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.resourceProviderNamespace,
        Parameters.parentResourcePath,
        Parameters.resourceType,
        Parameters.resourceName,
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.ManagementLockObject), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        201: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var deleteAtResourceLevelOperationSpec = {
    httpMethod: "DELETE",
    path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.resourceProviderNamespace,
        Parameters.parentResourcePath,
        Parameters.resourceType,
        Parameters.resourceName,
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {},
        204: {},
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getAtResourceLevelOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.resourceProviderNamespace,
        Parameters.parentResourcePath,
        Parameters.resourceType,
        Parameters.resourceName,
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var createOrUpdateAtSubscriptionLevelOperationSpec = {
    httpMethod: "PUT",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.ManagementLockObject), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        201: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var deleteAtSubscriptionLevelOperationSpec = {
    httpMethod: "DELETE",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {},
        204: {},
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getAtSubscriptionLevelOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks/{lockName}",
    urlParameters: [
        Parameters.lockName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockObject
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listAtResourceGroupLevelOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.filter,
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listAtResourceLevelOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.resourceProviderNamespace,
        Parameters.parentResourcePath,
        Parameters.resourceType,
        Parameters.resourceName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.filter,
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listAtSubscriptionLevelOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks",
    urlParameters: [
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.filter,
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listByScopeOperationSpec = {
    httpMethod: "GET",
    path: "{scope}/providers/Microsoft.Authorization/locks",
    urlParameters: [
        Parameters.scope
    ],
    queryParameters: [
        Parameters.filter,
        Parameters.apiVersion
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listAtResourceGroupLevelNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listAtResourceLevelNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listAtSubscriptionLevelNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listByScopeNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ManagementLockListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=managementLocks.js.map