import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a AvailableResourceGroupDelegations. */
export declare class AvailableResourceGroupDelegations {
    private readonly client;
    /**
     * Create a AvailableResourceGroupDelegations.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Gets all of the available subnet delegations for this resource group in this region.
     * @param location The location of the domain name.
     * @param resourceGroupName The name of the resource group.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailableResourceGroupDelegationsListResponse>
     */
    list(location: string, resourceGroupName: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailableResourceGroupDelegationsListResponse>;
    /**
     * @param location The location of the domain name.
     * @param resourceGroupName The name of the resource group.
     * @param callback The callback
     */
    list(location: string, resourceGroupName: string, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
    /**
     * @param location The location of the domain name.
     * @param resourceGroupName The name of the resource group.
     * @param options The optional parameters
     * @param callback The callback
     */
    list(location: string, resourceGroupName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
    /**
     * Gets all of the available subnet delegations for this resource group in this region.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailableResourceGroupDelegationsListNextResponse>
     */
    listNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailableResourceGroupDelegationsListNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailableDelegationsResult>): void;
}
//# sourceMappingURL=availableResourceGroupDelegations.d.ts.map