import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a AzureFirewallFqdnTags. */
export declare class AzureFirewallFqdnTags {
    private readonly client;
    /**
     * Create a AzureFirewallFqdnTags.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Gets all the Azure Firewall FQDN Tags in a subscription.
     * @param [options] The optional parameters
     * @returns Promise<Models.AzureFirewallFqdnTagsListAllResponse>
     */
    listAll(options?: msRest.RequestOptionsBase): Promise<Models.AzureFirewallFqdnTagsListAllResponse>;
    /**
     * @param callback The callback
     */
    listAll(callback: msRest.ServiceCallback<Models.AzureFirewallFqdnTagListResult>): void;
    /**
     * @param options The optional parameters
     * @param callback The callback
     */
    listAll(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AzureFirewallFqdnTagListResult>): void;
    /**
     * Gets all the Azure Firewall FQDN Tags in a subscription.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.AzureFirewallFqdnTagsListAllNextResponse>
     */
    listAllNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.AzureFirewallFqdnTagsListAllNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listAllNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.AzureFirewallFqdnTagListResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listAllNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AzureFirewallFqdnTagListResult>): void;
}
//# sourceMappingURL=azureFirewallFqdnTags.d.ts.map