/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/networkInterfaceLoadBalancersMappers";
import * as Parameters from "../models/parameters";
/** Class representing a NetworkInterfaceLoadBalancers. */
var NetworkInterfaceLoadBalancers = /** @class */ (function () {
    /**
     * Create a NetworkInterfaceLoadBalancers.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function NetworkInterfaceLoadBalancers(client) {
        this.client = client;
    }
    NetworkInterfaceLoadBalancers.prototype.list = function (resourceGroupName, networkInterfaceName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            networkInterfaceName: networkInterfaceName,
            options: options
        }, listOperationSpec, callback);
    };
    NetworkInterfaceLoadBalancers.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return NetworkInterfaceLoadBalancers;
}());
export { NetworkInterfaceLoadBalancers };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkInterfaces/{networkInterfaceName}/loadBalancers",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.networkInterfaceName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.NetworkInterfaceLoadBalancerListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.NetworkInterfaceLoadBalancerListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=networkInterfaceLoadBalancers.js.map