/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/peerExpressRouteCircuitConnectionsMappers";
import * as Parameters from "../models/parameters";
/** Class representing a PeerExpressRouteCircuitConnections. */
var PeerExpressRouteCircuitConnections = /** @class */ (function () {
    /**
     * Create a PeerExpressRouteCircuitConnections.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function PeerExpressRouteCircuitConnections(client) {
        this.client = client;
    }
    PeerExpressRouteCircuitConnections.prototype.get = function (resourceGroupName, circuitName, peeringName, connectionName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            circuitName: circuitName,
            peeringName: peeringName,
            connectionName: connectionName,
            options: options
        }, getOperationSpec, callback);
    };
    PeerExpressRouteCircuitConnections.prototype.list = function (resourceGroupName, circuitName, peeringName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            circuitName: circuitName,
            peeringName: peeringName,
            options: options
        }, listOperationSpec, callback);
    };
    PeerExpressRouteCircuitConnections.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return PeerExpressRouteCircuitConnections;
}());
export { PeerExpressRouteCircuitConnections };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/peerConnections/{connectionName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.circuitName,
        Parameters.peeringName,
        Parameters.connectionName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.PeerExpressRouteCircuitConnection
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/peerConnections",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.circuitName,
        Parameters.peeringName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.PeerExpressRouteCircuitConnectionListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.PeerExpressRouteCircuitConnectionListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=peerExpressRouteCircuitConnections.js.map